#include <iostream>
#include <sstream>
#include <vector>
#include "histogram.h"
#include "text.h"
#include "svg.h"
#include <curl/curl.h>

using namespace std;
struct Input {
    vector<double> numbers;
    size_t bin_count{};
};
Input
input_data(istream& in, bool prompt){
    size_t number_count;
    if (prompt)cerr << "Enter number count =  ";
    in >> number_count;

    Input inn;
    inn.numbers.resize(number_count);
    for (size_t i = 0; i < number_count; i++)
    {
        in >> inn.numbers[i];
    }
    if (prompt)
        cerr << "Enter bin_count = ";
    in >> inn.bin_count;
    return inn;
}
size_t
write_data(void* items, size_t item_size, size_t item_count, void* ctx) {
    stringstream* buffer = reinterpret_cast<stringstream*>(ctx);
    size_t data_size = item_size * item_count;
    (*buffer).write(reinterpret_cast<const char*>(items), data_size);
    return data_size;
}
Input
download(const string& address) {
    stringstream buffer;
    CURL* curl = curl_easy_init();
        if (curl) {
            curl_version_info_data *dataCV = curl_version_info(CURLVERSION_NOW);
            cerr << "SSL version = "<< dataCV->ssl_version << endl;
            cerr << "Curl version = " << dataCV->version << endl;
            CURLcode res;
            curl_easy_setopt(curl, CURLOPT_URL, address.c_str());
            curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
            curl_easy_setopt(curl, CURLOPT_WRITEDATA, &buffer);
            res = curl_easy_perform(curl);
            if (res != CURLE_OK) {
                cerr << curl_easy_strerror(res);
                exit(1);
            }
            curl_easy_cleanup(curl);
        }
    return input_data(buffer,false);
}

int main(int argc, char* argv[]){
    Input in;
    if (argc > 1) {
        in = download(argv[1]);
    } else {
        in = input_data(cin,true);
    }
    curl_global_init(CURL_GLOBAL_ALL);
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_svg(bins);

    return(0);
}















